VERSION 5.00
Begin VB.Form TsForm 
   Caption         =   "Form1"
   ClientHeight    =   7020
   ClientLeft      =   60
   ClientTop       =   510
   ClientWidth     =   9105
   LinkTopic       =   "Form1"
   ScaleHeight     =   7020
   ScaleWidth      =   9105
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdRelease 
      Caption         =   "Stop"
      Height          =   495
      Left            =   4440
      TabIndex        =   4
      Top             =   4200
      Width           =   1575
   End
   Begin VB.CommandButton cmdRequest 
      Caption         =   "Start"
      Height          =   495
      Left            =   2880
      TabIndex        =   3
      Top             =   4200
      Width           =   1455
   End
   Begin VB.TextBox edtSymbol 
      Height          =   495
      Left            =   1200
      TabIndex        =   2
      Top             =   4200
      Width           =   1575
   End
   Begin VB.ListBox list 
      Height          =   3960
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   8775
   End
   Begin VB.Label Label1 
      Caption         =   "Symbol:"
      Height          =   375
      Left            =   120
      TabIndex        =   1
      Top             =   4200
      Width           =   855
   End
End
Attribute VB_Name = "TsForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim WithEvents esignal As IESignal.Hooks
Attribute esignal.VB_VarHelpID = -1
Dim sLastSymbol As String
Dim lTsHandle As Long
Dim lLastTsCount As Long
Dim lLastTsRtCount As Long
Private Sub ReleaseTS()
    If lTsHandle <> 0 Then
        esignal.ReleaseTimeSales lTsHandle
        lTsHandle = 0
        lLastTsCount = 0
    End If
End Sub

Private Sub cmdRelease_Click()
    ReleaseTS
End Sub

Private Sub cmdRequest_Click()
    Dim sSymbol As String
    
    sSymbol = edtSymbol.Text
    Trim (sSymbol)
    
    If sSymbol = "" Then
        Exit Sub
    End If
    
    ReleaseTS
    
    Dim tsFilter As IESignal.TimeSalesFilter
    tsFilter.sSymbol = sSymbol
    tsFilter.bQuotes = True
    tsFilter.bTrades = True
    tsFilter.lNumDays = 1
    tsFilter.bFilterPrice = False
    tsFilter.bFilterVolume = False
    tsFilter.bFilterQuoteExchanges = False
    tsFilter.bFilterTradeExchanges = False
    
    list.Clear
    
    lTsHandle = esignal.RequestTimeSales(tsFilter)
    
End Sub
Private Sub Form_Load()
    Set esignal = New IESignal.Hooks
    lTsHandle = 0
    
    esignal.SetApplication ("medgar")
    'Do While esignal.IsEntitled() = False
     '   Thread.Sleep (1000)
    'Loop

End Sub


Private Sub Form_Unload(Cancel As Integer)
    ReleaseTS
    Set esignal = Nothing
End Sub

Private Sub esignal_OnTimeSalesChanged(ByVal lHandle As Long)
    FillTS
End Sub

Private Function FormatTS(item As TimeSalesData)
    Dim sRet As String
    
    If item.DataType = tsdNA Then
        sRet = "NA"
    Else
        sRet = Str$(item.dtTime)
        
        
        If item.DataType = tsdTRADE Then
            sRet = sRet + ", Trade"
        ElseIf item.DataType = tsdBID Then
            sRet = sRet + ", Bid"
        ElseIf item.DataType = tsdASK Then
            sRet = sRet + ", Ask"
        End If
        
        sRet = sRet + ", " + Str$(item.dPrice)
        sRet = sRet + ", " + Str$(item.lSize)
        sRet = sRet + ", " + item.sExchange
    End If
    
    FormatTS = sRet
End Function
Private Sub FillTS()
    Dim lNumBars, lNumRtBars, lBar, lDiff As Long
    Dim item As IESignal.TimeSalesData
    
    ' only showing realtime bars.
    lNumRtBars = esignal.GetNumTimeSalesRtBars(lTsHandle)
    lNumBars = esignal.GetNumTimeSalesBars(lTsHandle)
    
    ' how many new bars since last time?
    lDiff = (lNumRtBars - lLastTsRtCount) * -1
    
    For lBar = lDiff + 1 To 0
        item = esignal.GetTimeSalesBar(lTsHandle, lBar)
        sBar = FormatTS(item)
        list.AddItem sBar, 0
    Next lBar
    
    lLastTsRtCount = lNumRtBars
    
    
    
    
End Sub

